
/**********************************************************************/
/*                                                                    */
/* Copyright (c) 2001 by Sun Microsystems, Inc.                       */
/* All rights reserved.                                               */
/*                                                                    */
/**********************************************************************/


/* $Date:   19 Sep 2001 16:47:36  $ */
/* $Modtime:   18 Sep 2001 16:42:28  $ */

#ifndef	lint
#ifdef __STDC__
const
#endif
static char sccsid[] = "@(#) $Workfile:   cvlwrupr.c  $ $Revision:   1.0  $";
#endif

/*
 * $Log:   /unikix/source2/SunMTP7.2.0/unikixsrc/user/convert/PVCS/cvlwrupr.c_v  $
 * 
 *    Rev 1.0   19 Sep 2001 16:47:36   unikix
 * Initial 7.2
 * 
 *    Rev 1.0   30 Jan 2000 11:47:48   unikix
 * Initial 7.0
 * 
 *    Rev 1.0   15 Mar 1999 19:59:54   unikix
 * Initial 6.0
 * 
 *    Rev 1.0   05/22/97 17:33:14   unikix
 * Initial 5.1
 * 
 *    Rev 1.0   04/10/96 14:13:02   unikix
 * Initial 5.0
 * 
 *    Rev 1.0   12/28/94 15:18:12   unikix
 * Initial revision (from V410ad)
 * 
 *    Rev 1.0.1.2   10/26/94 09:53:02   alan
 * Load conversion tables into memory
 * 
 *    Rev 1.0.1.1   09/16/94 16:10:08   randyh
 * Move rev 1.1 to V410u
 * 
 *    Rev 1.0.1.0   11/18/93 16:33:36   unikix
 * UniKix 4.1 baseline (from V400m)
 * 
 *    Rev 1.1   07/06/94 17:01:22   randyh
 * Kaschewski: more unsigned char problems.
 * 
 *    Rev 1.0   06/10/93 11:58:38   unikix
 * UniKix 3.1.2 version
 */

/*
cvlwrupr.c exported routines:
	cvlwrupr
cvlwrupr.c has no exported variables
cvlwrupr.c imports:
	toupper
*/

/*
**Name	     :	CVLWRUPR
**		This subroutine	converts an array of characters	to
**		upper case.
**
**		1.2	    (91/02/15)
**
**Parameters :	PINCHAR: is the	first character	of the string to be
**		converted.
**		PLENGTH: is the	number of characters to	convert.
**
**Return     :	This procedure returns the string starting at PINCHAR
**		with PLENGTH character converted to upper case.
**
**External   :	TOUPPER(<char>).  Converts a character from lower case
**		to upper case.
**		CTYPE.H	 Functions for the classification and conversion
**		of characters.
**
*/

/* ------------- unix includes ------------- */
#include <ctype.h>

#include "kxcnv.h"

void cvlwrupr(pinchar, plength)
unsigned char *pinchar;
int  plength;
{
	register   li;	     /*loop index */
	unsigned char *linchar;	     /*local for pinchar*/

	linchar	= pinchar;
	for (li	= 0; li	< plength; li++)
	    {
	    *linchar = lwr2upr(*linchar);
	    linchar++;
	    }
	return;
}
